Unit Misc;


interface

uses      dos,vars,func;

const     CRTC_UNDERLINE_LOC	     =	20;
          SEQ_ADDR		          =	$3C4;
          SEQ_DATA	    	          =	$3C5;
          SEQ_MEMORY_MODE		=	4;
          SEQ_04h_C4		     =	8;
          SEQ_04h_OE		     =	4;
          SEQ_04h_EM		     =	2;
          CRTC_ADDR		          =	$3D4;
          CRTC_DATA	  	          =	$3D5;
          CRTC_OFFSET		     =    19;
          CRTC_MODE_CTRL		     =	23;
          CRTC_14h_DW		     =	$40;
          CRTC_14h_CB4		     =	$20;
          CRTC_14h_UL		     =	$1F;
          CRTC_17h_HR		     =	$80;
          CRTC_17h_WB		     =	$40;
          CRTC_17h_AW		     =	$20;
          CRTC_17h_CBT		     =	$08;
          CRTC_17h_HRS		     =	$04;
          CRTC_17h_SRS		     =	$02;
          CRTC_17h_CMS		     =	$01;
          CRTC_START_ADDR_HIGH	=	12;
          CRTC_START_ADDR_LOW	     =	13;
          GRAPHC_ADDR		     =	$3CE;
          GRAPHC_DATA		     =	$3CF;
          GRAPHC_SR		          =	0;
          GRAPHC_ENABLE_SR	     =	1;
          GRAPHC_DATA_ROTATE	     =	3;
          GRAPHC_MODE		     =	5;
          GRAPHC_BIT_MASK	     =	8;
          SHIFT_REG_2		     =	$40;
          READ_MODE_0		     =	$00;
          READ_MODE_1		     =	$8;
          WRITE_MODE_0		     =	$00;
          WRITE_MODE_1		     =	01;
          WRITE_MODE_2		     =	02;
          WRITE_MODE_3		     =	03;


          PixelTable : array[0..3] of word = ($0102,$0202,$0402,$0802);

          MaxX     = 320;
          MaxY     = 192;


type      tscr = array[0..64000+12] of byte;
		pScr = ^tScr;
		tmap	= array[0..64000+12] of byte;
{		tmap	= array[0..16000+12] of byte;}
          pMap = ^tMap;
          tscrr= array[0..199,0..319] of byte;
          pscrr= ^tscr;
          tPBuff= array[0..200,1..2] of longint;
          pPBuff= ^tPBuff;

          tXY  = record
                   x : integer;
                   Y : integer;
                 end;


          tCOl = record
          		r : byte;
                    g : byte;
                    b : byte;
          End;
          tAcol = array [0..255] of tCol;
          pColours = ^tACol;

          tIndex = array[0..255] of byte;
          pIndex = ^tIndex;


          tClipData= record
					xcord : integer;			{ new x and Y cords}
					ycord : integer;
					xs    : integer;				{ X size (loop) }
					ys    : integer;				{ Y size (loop) }
					Dmod  : integer;		     { Dest Modulo   }
					Smod  : integer;		     { Source Modulo }
                         offs  : integer;
			          data  : pointer;
					RealX : integer;			{ real X size   }
					RealY : integer;			{ real Y size   }
					FracX : integer;			{ Start fraction on X }
					FracY : integer;			{ Start fraction on Y }
          End;

          tClipWindow = record
					x1   :  integer;			{ Clip window on screen }
					y1   :  integer;
					x2   :  integer;
					y2   :  integer;
          End;

VAR
          ClipData       : tClipData;
          ClipWindow     : tClipWindow;
          Colours		: pColours;
          Font    		: Pointer;
		FontS   		: longint;

          ScreenX2       : word;
          ScreenX        : word;
          ScreenY        : word;

          ScreenWidth    : word;
          BufferFlag     : byte;
          PlaneTotal     : word;
          ScrBase        : word;   { Current DRAWING base }
          Wx1            : word;   { Drawing window       }
          Wx2            : word;
          Wy1            : word;
          Wy2            : word;

          PanX           : word;
          PanY           : word;

          Clipped		: word;
          Currentscreen : word;    { 0 or 1 }

          i			: word;
          MaskScreen	: pMap;
          Scr  		: pMap;

          IndexTable     : pIndex;
          scx,scy,Dx1,Dy1,Dx2,Dy2 : longint;
          RealScreen     : pointer;

          scrbuff        : pPBuff;
          Poly           : array[1..32]  of tXY;
          PolyNumber     : word;
          PolyPoints     : pointer;
          PolyCol        : byte;

Procedure DoFill;
Procedure DrawPoly;
Procedure TextureMap (x1,y1 : integer; Shape : pointer);
Procedure ClearMem (buff : pointer; S : word);
Procedure CopyMem (p1 : pointer; p2 : pointer; s : word);
Procedure	Plot (X,Y : integer; col : byte);
Procedure Clip (x,y,Xsize,Ysize : integer; Sprite : pointer);
Procedure SetClipWindow (x1,y1,x2,y2 : word);
Procedure pastesprite(Scr : pointer);
Procedure PrintSprite (Scr : pointer; x,y,Xsize,Ysize : integer; Ang : word; Data : pointer);
Procedure PrintBlock (Scr : pointer; x,y,Xsize,Ysize : integer; Data : pointer);
Function  IncP (p : pointer; I : word) : pointer;
Procedure fillbox (x,y,xs,ys : word; col : byte);
Procedure FlipBuffers (PanX,PanY : word);

Procedure Copy320MapScreen;
Procedure CopyMapScreen;
Procedure CopyMapScreen2;
Procedure ClearMapScreen;
Procedure ClearScreen;
Function  DecP (p : pointer; I : word) : pointer;
Procedure Draw (sc: pointer; x1,y1,x2,y2 : longint;col : byte);
{Procedure DrawScaledBlock;
Procedure DrawScaledBlockY;
Procedure DSBClipped;
Procedure DSBClippedY;}
Procedure CopyMAPSize;


implementation
{$L draw.obj}
{ $L top1.obj}
{ $L side1.obj}
Procedure ClearScreen; External;
Procedure TextureMap (x1,y1 : integer; Shape : pointer); External;
Procedure ClearMapScreen; External;
Procedure Copy320MapScreen; External;
Procedure CopyMapScreen; External;
Procedure CopyMapScreen2; External;
Procedure CopyMAPSize; External;

{Procedure DrawScaledBlock; External;
Procedure DrawScaledBlockY; External;
{Procedure DSBClipped;  External;
Procedure DSBClippedY; External;}


(**************************************************************************)
(*
(*	Flip Buffers
(*
(**************************************************************************)
(*Procedure FlipBuffers;
          VAR ScrOf : word;
Begin
     ScrBase:=ScrBase xor $4000;
     ScrOf:=ScrBase;
     asm
        mov     bx,ScrBase;
	   mov     dx,CRTC_ADDR
	   mov     bl,al                           { save lsb of offset }
	   mov     al,CRTC_START_ADDR_HIGH
	   out     dx,ax                           { output msb of offset }
	   mov     ah,bl
	   inc     al
	   out     dx,ax                           { output lsb of offset }
     End;
End;
*)

(**************************************************************************)
(*
(*	Flip Buffers
(*
(**************************************************************************)
Procedure FlipBuffers (PanX,PanY : word);
          VAR ScrOf : word;
Begin
     asm
        cli
        mov     al,BufferFlag
        xor     al,255
        mov     BufferFlag,al

        mov     bx,ScrBase         { work out index into screen }
        mov     ax,PanY
        mul     ScreenX2
        mov     cx,PanX
        shr     cx,2
        add     ax,cx
        add     bx,ax

	   mov     dx,CRTC_ADDR
	   mov     ah,bh                           { save lsb of offset }
	   mov     al,CRTC_START_ADDR_HIGH
	   out     dx,ax                           { output msb of offset }
	   mov     ah,bl
	   inc     al
	   out     dx,ax                           { output lsb of offset }


          mov  dx,003dah
@loop:    in   al,dx
          and  al,8
          cmp  al,8
          je   @loop

          mov  dx,003dah
@loop2:   in   al,dx
          and  al,8
          cmp  al,8
          jne   @loop2


        mov     cx,panx
        and     cl,3
        shl     cl,1
        mov     dx,03c0h
        mov     al,013h or 020h             { $13 OR $20 }
        out     dx,al
        mov     al,cl
        out     dx,al


        mov     bx,ScrBase         { work out index into screen }
        xor     bx,PlaneTotal
        mov     ScrBase,bx

        mov	 ax,CurrentScreen
        xor	 ax,1
        mov	 CurrentScreen,ax
        sti

      End;
End;

(************************************************************************)
(*
(*   Set up Mode X.
(*
(*   Seq, Crt, Graph.
(*
(************************************************************************)
Procedure SetModeX (sX,SY : word);
Begin
     PlaneTotal:=(sX div 4)*sY;
     ScreenX:=Sx;
     ScreenX2:=Sx div 4;
     ScreenY:=Sy;
     ScreenWidth:=sX div 4;

		Rset.Ah:=$0f;
		Intr ($10,Rset);
		Dmode:=Rset.Al;

		Rset.ax	:= $13;			(* Select Mode		   *)
		Intr	($10,Rset);


(*     port[$3d4]:=21;     { set Vblanking space }
     port[$3d5]:=143;
     port[$3d4]:=22;
     port[$3d5]:=0;
*)
     { setup Sequencer }

	port[SEQ_ADDR]:=SEQ_MEMORY_MODE;
     port[SEQ_DATA]:=Port[SEQ_DATA] and (NOT SEQ_04h_C4);

{------}
	Port[CRTC_ADDR]:=CRTC_UNDERLINE_LOC;
     Port[CRTC_DATA]:=Port[CRTC_DATA]and (NOT CRTC_14h_DW);

	Port[CRTC_ADDR]:=CRTC_MODE_CTRL;
     Port[CRTC_DATA]:=Port[CRTC_DATA] or CRTC_17h_WB;

	Port[CRTC_ADDR]:=CRTC_OFFSET;           { set screen width }
     Port[CRTC_DATA]:=ScreenX div 8;

{---------}
	Port[GRAPHC_ADDR]:=GRAPHC_SR;
     Port[GRAPHC_DATA]:=0;
	Port[GRAPHC_ADDR]:=GRAPHC_ENABLE_SR;
     Port[GRAPHC_DATA]:=0;
	Port[GRAPHC_ADDR]:=GRAPHC_DATA_ROTATE;
     Port[GRAPHC_DATA]:=0;
	Port[GRAPHC_ADDR]:=GRAPHC_MODE;
     Port[GRAPHC_DATA]:=(SHIFT_REG_2 + READ_MODE_0 + WRITE_MODE_0 );
     Port[GRAPHC_ADDR]:=GRAPHC_BIT_MASK;
     Port[GRAPHC_DATA]:=$FF;
End;


(**************************************************************************)
(*
(*	Inc a Pointer
(*
(**************************************************************************)
Function DecP (p : pointer; I : word) : pointer;
		VAR pp : pointer;
Begin
     pp:=p;
	ASM
          mov	ax,I
          sub	[bp-8],ax
     END;
     DecP:=pp;
End;
(**************************************************************************)
(*
(*	Inc a Pointer
(*
(**************************************************************************)
Function IncP (p : pointer; I : word) : pointer;
		VAR pp : pointer;
Begin
     pp:=p;
	ASM
          mov	ax,I
          add	[bp-8],ax
     END;
     IncP:=pp;
End;

(**************************************************************************)
(*
(* Clear an area of memory (in WORDS!)
(*
(**************************************************************************)
Procedure ClearMem (buff : pointer; S : word);
Begin
	Asm
		push es
		les	di,buff	{ get graphics address }
          xor  ax,ax
          mov  si,ax
          mov  cx,s

		rep	stosw

          pop	es
	End;
End;

(**************************************************************************)
(*
(*	Copy memory in WORDS.. (Source,Dest,Size)
(*
(**************************************************************************)
Procedure CopyMem (p1 : pointer; p2 : pointer; s : word);
Begin
	Asm
		push	ds			{ save the segments as we probably }
		push	es			{ shouldn't mess with them         }
		mov	cx,s
		les	di,p2		{ get mem block 1 }
		lds	si,p1
          rep  movsw

          pop	es			{ restore the segments }
		pop	ds
	End;
End;

(***************************************************************************)
(*
(*  Plot a pixel
(*
(***************************************************************************)
Procedure	Plot (X,Y : integer; col : byte);
          VAR t : word;
          const tt : array[0..3] of word = ($0102,$0202,$0402,$0802);
Begin
(*     if (x<0) or (x>319) then exit;
     if (y<0) or (y>199) then exit;
     t:=tt[x and 3];
     asm
          mov  di,X
          cmp  di,320
          ja   @ExitPlot
          mov	ax,Y
		cmp  ax,199			{ Clip pixel }
          ja   @ExitPlot


 		push	di
          push	es

          mov  dx,VidSeg           { get BASE of VRAM }
          mov  es,dx
          mov  bx,$102             { get PLANE to do }
          mov  cx,di               { GET X bits(plane) }
          and  cx,3
          shl  bh,cl               { mask plane to use }

          mul  ScreenX2            { mul Y*Screen width }
          shr  di,2                { +X/4 (for planes   }
		add	di,ax               { got START address  }
          add	di,ScrBase


	     mov  dx,GRAPHC_ADDR
	     mov  ax,$0001
	     out  dx,ax          { Enable Set/Reset }
	     mov  ax,$0003
	     out  dx,ax          { Data Rotate = 0, Func = Rep }
	     mov  ax,$4005
	     out  dx,ax          { Wr Mode 0, Rd Mode 1 }
	     mov  ax,$ff08
	     out  dx,ax          { Bitmask = 0ffh }

          mov  ax,bx
	     mov  dx,SEQ_ADDR
	     out  dx,ax           { Enable plane }
          mov  al,col
		stosb

          pop  es
          pop  di
@ExitPlot:
     End*)

     if Y>=200 then exit;
     if X>=maxx then exit;
     if Y<0 then exit;
     if X<0 then exit;

     Scr^[X+(y*320)]:=col;

End;


(***************************************************************************)
(*
(*   Paste Sprite Scale
(*
(***************************************************************************)
Procedure pastespriteScale (Scr : pointer; ScaleX,ScaleY : word);
		VAR	xsize,smods : word;
		VAR	ScreenXwidth,Xreal,Yreal,Sy,FracOnX,Xwidth : word;
Begin
 Asm
		push	es
		push	ds
		push	si
		push  di

		les	di,scr         	{ get screen address }
		add	di,ClipData.xcord	{ get x and y }
		mov	dx,ClipData.ycord

		mov	ax,320/4
		mul	dx
		add	di,ax			{ di = offset }


		lds	si,ClipData.data	{ get graphic address }
		mov	ax,320/4              { line size }
		mov	[ScreenXwidth],ax
		mov	ax,ClipData.FracX
		mov  [FracOnX],ax
		mov	ax,ClipData.xs	     { copy params BEFORE DS is lost }
		mov  [Xwidth],ax
		mov	ax,ClipData.RealX
		mov	[XReal],ax
		mov	ax,ClipData.RealY
		mov	[YReal],ax
		mov	ax,ClipData.FracY
		mov	[Sy],ax		     { set 0.W only lower byte is used for fraction }

@LoopYs2:
		push	si				{ store graphic index }
		push	di				{ store display index }
		mov	dx,[FracOnX]        { clear scale X fractional accumulator}
		xor	bx,bx			{ clear bh, always 0 inside inner loop }
		mov	cx,[Xreal]		{ get overall size}

@LoopXs2:
		mov	al,ds:[si]     	{ get byte from graphic }
		and	al,al     	     { test for 0?           }
		jz	@NoStore3   	     { if zero then no print }
		mov	es:[di],al          { store byte            }

@NoStore3:
		inc	di				{ inc dest }
		add	dx,ScaleX	          { add scale value to current fraction index}
		mov	bl,dh			{ copy over WHOLE number inc}
		xor	dh,dh			{ mask off whole number (keep fraction)}
		add	si,bx			{ add on pixel index (to get to next pixel)}
		loop	@LoopXs2

		pop	di				{ restore display index, and move to next line}
		add	di,[ScreenXwidth]	{ next line down}

		mov	bx,ScaleY			{ get SCALE on Y.W}
		add	bx,[Sy]			{ add scale value to current fraction index}
		mov	[BYTE PTR Sy],bl	{ Store NEW fraction, ignore upper byte (0)}
		mov	ax,[Xwidth]		{ get size on X}
		sar	bx,8				{ get WholeNumbers/Lines to SKIP}
		mul	bx				{ xply by WHOLE number}
		pop	si
		add	si,ax

		dec	[Yreal]			{ get current pixel down (y count)}
		jnz	@LoopYs2			{ if <Y size loop}

		pop	di
		pop	si
		pop	ds
		pop	es
  End;
End;

(*****************************************************************************)
(*
(*	Work out CLIP data, and make a up ClipStructure for draw routines
(*
(*****************************************************************************)
(*void	ClipScaled (int x,int y,int Xsize,int Ysize,int ScaleX,int ScaleY,char far *Sprite)
          VAR mods : integer;
          VAR offs : word;
	     VAR	FracX,FracY : integer;
	     VAR	RealX,RealY : integer;
Begin
	RealY=(Ysize shl 8) div ScaleY;		{ first work out REAL x and y sizes }
	RealX=(Xsize shl 8) div ScaleX;

	{ Yclip }
	if (y<ClipWindow.y1) then
	begin
		RealY:=RealY-(ClipWindow.y1-y);	{ get new Y size }
		FracY:=(ClipWindow.y1-y)*ScaleX;	{ work out pixels down ($??.??) }
		offs=(FracY>>8)*Xsize;				// index DOWN on sprite
		FracY=FracY & 0xff;						// keep fractional part
		y=ClipWindow.y1;
	end;

	if (y+RealY > ClipWindow.y2)
	{
		RealY-=y+RealY-ClipWindow.y2;
	}

	// Xclip

	if (x<ClipWindow.x1)
	{
		RealX-=(ClipWindow.x1-x);			// dec loop size
		FracX=(ClipWindow.x1-x)*ScaleX;	// work out amount off screen
		Sprite+=FracX>>8;						// index in on sprite (whole no.)
		FracX=FracX & 0xff;					// keep fractional part
		x=ClipWindow.x1;						// set to left edge

	}
	if ((x+RealX)>ClipWindow.x2)
	{
		RealX-=x+RealX-ClipWindow.x2;	// set new X size
	}

	// set up clip struct

	ClipData.xcord=x+ClipWindow.Xoff;
	ClipData.ycord=y+ClipWindow.Yoff;
	ClipData.xs=Xsize;
	ClipData.ys=Ysize;
	ClipData.Dmod=ClipWindow.ScrXsize-RealX;
	ClipData.data=Sprite;

	ClipData.FracX=FracX;
	ClipData.FracY=FracY;
	ClipData.RealY=RealY;
	ClipData.RealX=RealX;
}

(*****************************************************************************)
(*
(*	Work out CLIP data, and make a up ClipStructure for draw routines
(*
(*****************************************************************************)
(*Procedure Clip (x,y,Xsize,Ysize : integer; Sprite : pointer);
          VAR mods : integer;
          VAR offs : word;
Begin
     Mods:=0;
     offs:=0;

	{ Yclip }
	if (y<ClipWindow.y1) then
	Begin
		Offs:=(ClipWindow.y1-y*Xsize);
		Ysize:=Ysize-(ClipWindow.y1-y);
		y:=ClipWindow.y1;
	End;

	if ((y+Ysize)>ClipWindow.y2) then
		Ysize:=ClipWindow.y2-y;


	{ Xclip }

	if (x<ClipWindow.x1) then
	Begin
		Mods:=Mods+ClipWindow.x1-x;			{ get index IN on sprite }
		offs:=offs+Mods;
		x:=ClipWindow.x1;
		Xsize:=Xsize-Mods;
	End;
	if ((x+Xsize)>ClipWindow.x2) then
	Begin
		Mods:=Mods+(x+Xsize)-ClipWindow.x2;	{ get overrun dist (and add to mod) }
		Xsize:=Xsize-((x+Xsize)-ClipWindow.x2);
	End;


	{ set up clip struct }

	ClipData.xcord:=x;
	ClipData.ycord:=y;
	ClipData.xs:=Xsize;
	ClipData.ys:=Ysize;
	ClipData.Smod:=Mods;
	ClipData.Dmod:=(320 div 4)-Xsize;
	ClipData.data:=Sprite;
	ClipData.offs:=offs;
End;*)

(*****************************************************************************)
(*
(*	Work out CLIP data, and make a up ClipStructure for draw routines
(*
(*****************************************************************************)
Procedure Clip (x,y,Xsize,Ysize : integer; Sprite : pointer);
          VAR mods : integer;
          VAR offs : word;
Begin
     Mods:=0;
     offs:=0;

	{ Yclip }
	if (y<ClipWindow.y1) then
	Begin
		Offs:=(ClipWindow.y1-y*Xsize);
		Ysize:=Ysize-(ClipWindow.y1-y);
		y:=ClipWindow.y1;
	End;

	if ((y+Ysize)>ClipWindow.y2) then
		Ysize:=ClipWindow.y2-y;


	{ Xclip }

	if (x<ClipWindow.x1) then
	Begin
		Mods:=Mods+ClipWindow.x1-x;			{ get index IN on sprite }
		offs:=offs+Mods;
		x:=ClipWindow.x1;
		Xsize:=Xsize-Mods;
	End;
	if ((x+Xsize)>ClipWindow.x2) then
	Begin
		Mods:=Mods+(x+Xsize)-ClipWindow.x2;	{ get overrun dist (and add to mod) }
		Xsize:=Xsize-((x+Xsize)-ClipWindow.x2);
	End;


	{ set up clip struct }

	ClipData.xcord:=x;
	ClipData.ycord:=y;
	ClipData.xs:=Xsize;
	ClipData.ys:=Ysize;
	ClipData.Smod:=Mods;
	ClipData.Dmod:=(320 div 4)-Xsize;
	ClipData.data:=IncP(Sprite,Offs);
	{ClipData.offs:=offs;}
End;



(*****************************************************************************)
(*
(*	Paste a SPRITE on screen Fast
(*
(****************************************************************************)
Procedure pastesprite(Scr : pointer);
		VAR	xsize,smods : word;
Begin
Asm
		push	es
		push	ds
		push	si
		push	di

		mov	ax,ClipData.xs
		mov	[xsize],ax

		les	di,scr         		{ get screen address }
		mov	ax,ClipData.Ycord
          shl  ax,6
          add  di,ax
          shl  ax,2
		add	di,ax				{ di = offset }
		add	di,ClipData.xcord		{  get x and y }


		mov	dx,ClipData.Smod		{ set SOURCE mod }
		mov	[smods],dx
		mov	dx,ClipData.Dmod		{ get screen modulo }

		mov	bx,ClipData.ys  		{ set up Y loop counter (0-255) }
          mov  ax,ClipData.offs
		lds	si,ClipData.data		{ get graphic address }
          add  si,ax

@LoopY:
		mov	cx,[xsize]			{ get size (inner) }
@LoopX:
		lodsb          	  		{ get byte in al }
		and	al,al     			{ 0? }
		jz	@NoStore	    			{ if zero then no print }
		stosb          			{ store byte }
		Loop	@LoopX     			{ loop all }
		jmp	@EndLoop

@NoStore:
		inc  di       				{ inc dest }
          loop @LoopX	    			{ loop }

@EndLoop:
		add	si,[smods]			{ add source mod }
		add	di,dx				{ move to next line }
		dec	bx
		jnz	@LoopY

		pop	di
		pop	si
		pop	ds
		pop	es
  End;
End;


(*****************************************************************************)
(*
(*	Paste a BLOCK on screen Fast.
(* 	Checks for WORD sized, or ODD sized, and runs the correct paste!
(*
(****************************************************************************)
(*Procedure PasteBlock(Scr : pointer);
		VAR	xsize,smods : word;
Begin
Asm
		push	es
		push	ds
		push	si
		push	di

		mov	ax,ClipData.xs
		mov	[xsize],ax

		les	di,scr         		{ get screen address }
		mov	ax,ClipData.Ycord
          shl  ax,6
          add  di,ax
          shl  ax,2
		add	di,ax				{ di = offset }
		add	di,ClipData.xcord		{  get x and y }


		mov	dx,ClipData.Smod		{ set SOURCE mod }
		mov	[smods],dx
		mov	dx,ClipData.Dmod		{ get screen modulo }

		mov	bx,ClipData.ys  		{ set up Y loop counter (0-255) }
          mov  ax,ClipData.offs
		lds	si,ClipData.data		{ get graphic address }
          add  si,ax

		mov	ax,[xsize]
          and	ax,1
          jnz	@ODD

		shr	[xsize],1
@OLoopY:
		mov	cx,[xsize]			{ get size (inner) }
		rep	movsw

		add	si,[smods]			{ add source mod }
		add	di,dx				{ move to next line }
		dec	bx
		jnz	@OLoopY
		jmp	@Exit

{ ODD loop. in NOT even. ie. can't do ONLY words! }
@ODD:
		shr	[xsize],1
@LoopY:
		mov	cx,[xsize]			{ get size (inner) }
		rep	movsw
          movsb					{ last one! }

		add	si,[smods]			{ add source mod }
		add	di,dx				{ move to next line }
		dec	bx
		jnz	@LoopY
@Exit:
		pop	di
		pop	si
		pop	ds
		pop	es
  End;
End;
*)

(***************************************************************************)
(*
(*   Print Sprite (x,y,Xsize,Ysize, Data)
(*
(***************************************************************************)
Procedure PrintSprite (Scr : pointer; x,y,Xsize,Ysize : integer; Ang : word; Data : pointer);
Begin
     SetColour (0,0,64,0);
     Clip (x,y,Xsize,Ysize,data);
     if (ClipData.xs<=0) or (
	CLipData.ys<=0) then exit;
     ClipData.Offs:=ClipData.offs+(Ang*Xsize*Ysize);
     {DrawSprite (x,y,ClipData.Data,Xsize,Ysize);}
     SetColour (0,0,0,0);
End;

(***************************************************************************)
(*
(*   Print Sprite (x,y,Xsize,Ysize, Data)
(*
(***************************************************************************)
Procedure PrintBlock (Scr : pointer; x,y,Xsize,Ysize : integer; Data : pointer);
Begin
     Clip (x,y,Xsize,Ysize,data);
     if (ClipData.xs<=0) or (CLipData.ys<=0) then exit;
     {DrawSprite (x,y,ClipData.Data,x,y);}
End;



(***************************************************************************)
(*
(*   Set CLIP window
(*
(***************************************************************************)
Procedure SetClipWindow (x1,y1,x2,y2 : word);
Begin
     ClipWindow.x1:=x1;
     Wx1:=x1;
     ClipWindow.y1:=y1;
     Wy1:=y1;
     ClipWindow.x2:=x2;
     Wx2:=x2;
     ClipWindow.y2:=y2;
     Wy2:=y2;
End;

(***************************************************************************)
(*
(*	Draw a FILLED box of colour "?"
(*
(***************************************************************************)
Procedure fillbox (x,y,xs,ys : word; col : byte);
		VAR Smod,mods : word;
          VAR Right,left : word;
          VAR xs2,xs3 : word;
          VAR Am : word;
          const table : array[1..4] of word =($0102,$0302,$0702,$0f02);
          const table2 : array[0..3] of word =($0f02,$0e02,$0c02,$0802);
          const table3 : array[0..3] of word =(4,3,2,1);
Begin
          Right:=Table  [((x+xs) and 3)]; { Right mask, left overs }
          Left :=Table2 [x and 3];      { left mask. START mask  }
          AM:=((x and 3) xor 3)+1;
 Asm
          mov	ax,xs
          cmp	ax,0
          jz	@Quit

 		push	si
 		push	di
          push	es

	     mov     dx, GRAPHC_ADDR
	     mov     ax, $0001
	     out     dx, ax          { Enable Set/Reset }
	     mov     ax, $0003
	     out     dx, ax          { Data Rotate = 0, Func = Rep }
	     mov     ax, $4005
	     out     dx, ax          { Wr Mode 0, Rd Mode 1 }
	     mov     ax, $ff08
	     out     dx, ax          { Bitmask = 0ffh }

          mov	ax,xs
          cmp	ax,0
          jz	@Quit
          mov  xs2,ax
          mov  bx,x
          add  ax,bx
          add  ax,3
          and  bx,$ffff-3
          sub  ax,bx
          shr  ax,2
          mov  xs3,ax


          mov  ax,VidSeg           { get BASE of VRAM }
          mov  es,ax
          mov	ax,y
          mov	di,x		          { add on X cord 	 }
          shr  di,2
          mul  ScreenX2
		add	di,ax               { got START address  }
          add  di,ScrBase

          mov	dx,ScreenX2
          sub	dx,xs3          	{ get MOD to next line }
          mov  SMod,dx

          mov  al,col
          xor  ah,ah
          mov  si,ax

          mov	bx,ys
@LoopY2:  mov  cx,xs2
	     mov  dx,SEQ_ADDR         { set planes for FIRST byte }
	     mov  ax,left
	     out  dx,ax               { Enable planes in first set of pixels }

          mov  ax,si               { store colour }
          stosb

          sub  cx,Am               { take off 1-3 pixels }
          cmp  cx,0
          jng  @Next

	     mov  dx,SEQ_ADDR         { set planes for FIRST byte }
	     mov  ax,$0f02            { enable all planes         }
	     out  dx,ax

          mov  ax,si               { main body of }
          mov  dx,cx
          shr  cx,2
		rep	stosb

          and  dx,3
          jz   @next
	     mov  dx,SEQ_ADDR         { set planes for FIRST byte }
	     mov  ax,Right
	     out  dx,ax               { Enable planes in first set of pixels }
          mov  ax,si
          stosb

@Next:    add	di,SMod
		dec	bx
		jnz	@LoopY2


          pop	es
		pop	di
 		pop	si

@Quit:
 End;
End;


(**************************************************************************************)
(*
(*   Draw a line to the buffer
(*
(**************************************************************************************)
Procedure Draw (sc: pointer; x1,y1,x2,y2 : longint;col : byte);
          VAR cnt : integer;
          VAR x,y : longint;
          VAR dx1,dy1 : longint;
          VAR scrr: pscrr;
Begin
     scrr:=sc;
     if abs (x2-x1)>=abs (y2-y1) then
        scx:=abs (x2-x1)
     else
         scx:=abs (y2-y1);
     if scx=0 then inc (scx);
     dx1:=((x2-x1)*256) div scx;
     dy1:=((y2-y1)*256) div scx;


     x:=(x1*256)+128;
     y:=(y1*256)+128;
     repeat
            {if (x>0) and (x<320*256) and (y>0) and (y<200*256) then
               scrr^[((y shr 8)*320)+(x shr 8)]:=col;}
            scrr^[((y shr 8)*320)+(x shr 8)]:=col;

            x:=x+dx1;
             y:=y+dy1;
            dec (scx);
      until (scx<0);
End;



(**************************************************************************************)
(*
(*   Draw a line to the buffer
(*
(**************************************************************************************)
Procedure DrawLine (x1,y1,x2,y2 : longint);
          VAR cnt : integer;
          VAR x,y : longint;
          VAR sc  : pscrr;
          VAR dx1,dy1 : longint;
          VAR xx,yy : integer;
          VAR v,v2 : longint;
Begin
     sc:=pointer(Vars.plane1); {ptr(segA000,0);}
     if abs (x2-x1)>=abs (y2-y1) then
        scx:=abs (x2-x1)
     else
         scx:=abs (y2-y1);
     if scx=0 then inc (scx);
     dx1:=((x2-x1)*$10000) div scx;
     dy1:=((y2-y1)*$10000) div scx;


     x:=(x1*$10000)+$8000;
     y:=(y1*$10000)+$8000;
     repeat
            if (x>0) and (x<320*$10000) and (y>0) and (y<200*$10000) then
            Begin
                 {sc^[((y shr 16)*320)+(x shr 16)]:=128;}
                 {xx:=x shr 16;}
                 yy:=y shr 16;

                 if x<0 then x:=0;
                 if x>(319*$10000) then x:=(319*$10000);
                 v:=ScrBuff^[yy,1];
                 v2:=ScrBuff^[yy,2];
                 if (x<v) or (v=-1) then
                  Begin
                      if v>v2 then ScrBuff^[yy,2]:=v;
                      ScrBuff^[yy,1]:=x;
                  End
                 else
                  if x>v2 then ScrBuff^[yy,2]:=x;
            End;

            x:=x+dx1;
            y:=y+dy1;
            dec (scx);
      until (scx<0);
End;


(**************************************************************************************)
(*
(*  DoFill: Fill poly lines;
(*
(**************************************************************************************)
Procedure DoFill;
          VAR sc  : pscrr;
          VAR i,i2  : integer;
          VAR v1,v2 : integer;
          VAR d : word;
Begin
     sc:=pointer(Vars.plane1); {ptr(segA000,0);}
     for i:=0 to 200 do
     Begin
          V1:=ScrBuff^[i,1] shr 16;
          V2:=ScrBuff^[i,2] shr 16;
          if (V1<>-1) and (V2<>-1) then
          Begin
             d:=i*320;
             For i2:=V1 to V2 do
                 sc^[d+i2]:=128;

          End;
     End;
End;


(**************************************************************************************)
(*
(*   Draw to buffer
(*
(*   PolyNumber=Number of poly points
(*
(**************************************************************************************)
Procedure DrawPoly;
          VAR curr,cnt : word;
          VAR sc  : pscrr;
          VAR i : integer;
Begin
     for i:=0 to 200 do             { Blank Edge table }
     begin
          ScrBuff^[i,1]:=-1;        { LEFT  edge }
          ScrBuff^[i,2]:=-1;        { RIGHT edge }
     End;


     cnt:=PolyNumber;
     curr:=1;
     repeat
           DrawLine(Poly[curr].x,Poly[curr].y,Poly[curr+1].x,Poly[curr+1].y);
           inc (curr);
           dec (cnt);
     until (cnt<=1);
     DrawLine(Poly[1].x,Poly[1].y,Poly[PolyNumber].x,Poly[PolyNumber].y);


     DoFill;

End;

(***************************************************************************)
(* Init Unit
(***************************************************************************)
Begin
     ScreenX:=320;
     Scr:=ptr(sega000,0);
     RealScreen:=ptr(sega000,0);
     PolyPoints:=@Poly;

End.